#include <stdio.h>

#ifndef WIN32
#include <unistd.h>
#else
#include <fcntl.h>
#include <io.h>
#endif

void
Image2Tcl(const char *objectName)
{
  unsigned char buffer[1024], *ptr;
  int i, bytesRead, stdin_FD=0;
  printf("set imageObject__ [new Image/GIF \"");
  while ((bytesRead=read(stdin_FD, buffer, sizeof(buffer))) > 0) {
    for (i=0, ptr=buffer; i<bytesRead; i++, ptr++) {
      switch (*ptr) {
      case '\0': 
	printf("\\%o\\%o", (unsigned short) '\\', (unsigned short) '#');
	break;
      case '\\': 
	printf("\\%o\\%o", (unsigned short) '\\', (unsigned short) '\\');
	break;
      default:   
	printf("\\%o", (unsigned short) *ptr); 
	break;
      }
    }
  }
  printf("\"]\n");
  printf("image create photo %s -data $imageObject__\n", objectName);
}


int 
main(int argc, char *argv[])
{
#ifdef WIN32
	_setmode(_fileno(stdin), _O_BINARY);
#endif
  if (argc!=2) {
    fprintf(stderr, "Usage: image2tcl <object-name>\n");
    return -1;
  }
  Image2Tcl(argv[1]);
  return 0;
}

