#ifndef srmv2_source_h
#define srmv2_source_h

#include "tclcl.h"
#include "inet.h"
#include "srmv2.h"
#include "pktbuf-srmv2.h"
#include "net.h"
#include "transmitter.h"

class NameMap;
class SRMv2_Session;
class SRMv2_RReq;
class adubuf;

class SRMv2_Source : public TclObject {
public:
	SRMv2_Source(const char *src_name);
	SRMv2_Source(const int *src_id);
	~SRMv2_Source();

	int command(int argc, const char*const* argv);
	int  source_id(int idx)    { return sid_[idx]; }
	int* source_id() { return sid_; }
	NameMap *namemap() { return namemap_; }
	unsigned int ipaddr() { return ipaddr_; }
	void ipaddr(unsigned int addr) { ipaddr_ = addr; }
	
private:
	int* sid_;
	NameMap* namemap_;
	SRMv2_Session* session_;
	unsigned int ipaddr_;   /* IPv4 address */
};
#endif



