Class NewscastUI

NewscastUI public init { w app as } {
	$self instvar w_ app_ as_ numhls_
	set w_ $w
	set app_ $app
	set as_ $as
	set numhls_ 0

	$self tkvar show_stocks show_hls
	set show_stocks 1
	set show_hls 1

	# top menu bar
	frame $w_.mb -relief raised -bd 2
	pack $w_.mb -side top -fill x

	# options menu button
	menubutton $w_.mb.opt -text "Options" -menu $w_.mb.opt.m
	pack $w_.mb.opt -side left
	menu $w_.mb.opt.m -tearoff no
	$w_.mb.opt.m add command -label "Configure content" -command "$self popup_conf"	
	$w_.mb.opt.m add command -label "Clear screen" -command "$self clear_hl"
	
	# init content configure 
	$self init_popup_conf

	# quit button
	menubutton $w_.mb.q -text Quit -menu $w_.mb.q.m
	pack $w_.mb.q -side right
	menu $w_.mb.q.m -tearoff no
	$w_.mb.q.m add command -label "Yes, really quit" -command "$self destroy"
	$w_.mb.q.m add command -label "No, don't quit"	

	focus $w_.mb

	frame $w_.main

	# Newscast section
	set div [label $w_.main.div -relief groove -text "Current Newscast...\n " -anchor nw]
	set end [label $w_.main.end -relief raised]
	set s [frame $w_.main.hl]
	set can $s.can
	set y $s.y
	canvas $can -width 8.1i -height 2.5i -scrollregion "0 0 8.1i 2.5i" \
			-takefocus 1 -yscrollcommand "$y set"
	scrollbar $y -orient vert -command "$can yview"
	frame $can.main
	$can create window 0 0 -anchor nw -window $can.main
	pack $y -side right -fill y
	pack $can -side left -expand true -fill both

	pack $div -expand t -fill x 
	pack $s -expand t -fill both -side top
	pack $end -expand t -fill x

	pack $w_.main

#	for {set i 0} {$i < 20} {incr i} {
#		$self mkrow_hl "LA la la la la la la la la" "http://www.cs.berkeley.edu"
#	}
	
}

NewscastUI public destroy { } {
	exit
}

NewscastUI public popup_conf { } {
	$self instvar confui_

	if [info exists confui_] {
		wm deiconify $confui_
		return
	}

	toplevel .conf
	set w .conf
	wm title $w "Configure content"

	$self tkvar news_ business_ sports_ tech_ entert_ \
		news_e_ business_e_ sports_e_ tech_e_ entert_e_
	frame $w.enter
	message $w.enter.inst -text "Please select categories from below, and enter specific keywords you are interested in." -aspect 1000
	pack $w.enter.inst -pady 10
	foreach cat "News Business Sports Technology Entertainment" {
		set c [string tolower $cat]
		global c$c v$c
		frame $w.enter.$c		
		checkbutton $w.enter.$c.c -text $cat -variable c$c -width 15 -anchor w
		label $w.enter.$c.l -text "Keywords:"
		entry $w.enter.$c.e -textvariable v$c
		pack $w.enter.$c.c $w.enter.$c.l $w.enter.$c.e -side left -expand true -fill x
		pack $w.enter.$c -side top -anchor nw
	}
	
	frame $w.buttons
	button $w.buttons.ok -text OK -command "wm withdraw $w; $self change_pref"
	button $w.buttons.cancel -text Cancel -command "wm withdraw $w"
	button $w.buttons.clear -text Clear -command "$self clear_popup_conf"
	pack $w.buttons.ok $w.buttons.cancel $w.buttons.clear \
		-side left -fill x -expand true -padx 5

	pack $w.enter $w.buttons -pady 10 -padx 5	

	set confui_ $w
}

NewscastUI private clear_popup_conf { } {
	foreach cat "News Business Sports Technology Entertainment" {
		set c [string tolower $cat]
		global c$c v$c
		set c$c 0
		set v$c {}
	}
}

NewscastUI private init_popup_conf { } {
	foreach cat "News Business Sports Technology Entertainment" {
		set c [string tolower $cat]
		global c$c v$c
		if { "$cat" == "News" } {
			set c$c 1
		} else {
			set c$c 0
		}
		set v$c ""
	}

	$self instvar pref_
	set pref_ [$self get_pref]
}

NewscastUI public change_pref { } {
	$self instvar app_ as_ pref_
	global ssd
	
	set pref_ [$self get_pref]
	set ssd(pref) $pref_
	$as_ set_agent_data [array get ssd]

	$app_ regroup
}

NewscastUI public get_pref { } {
	foreach cat "News Business Sports Technology Entertainment" {
		set c [string tolower $cat]		
		global c$c v$c
		if { [set v$c] == "" } {
			set v *
		} else {
			set v [set v$c]
		}
		if { [set c$c] == 1 } {
			lappend all [list $cat $v]
		}
	}
	return $all
}

NewscastUI public clear_hl { } {
	$self instvar w_ numhls_

	set numhls_ 0
	set can $w_.main.hl.can
	destroy $can.main

	frame $w_.main.hl.can.main
	$can create window 0 0 -anchor nw -window $can.main
	$can conf -scrollregion "0 0 8.1i 2.5i"
	
}

NewscastUI public mkrow_hl { hl url } {
	$self instvar w_ numhls_

	incr numhls_

	set can $w_.main.hl.can

	set f [frame $can.main.f$numhls_]
	label $f.l -bitmap bullet -foreground blue
	frame $f.mf
	label $f.mf.hl -justify left -text $hl

	pack $f.l -side left -anchor nw -padx 5 -pady 5
	pack $f.mf -side left -expand true -fill both
	pack $f.mf.hl -side top -anchor nw

	bind $f.l <Button-1> "exec netscape -remote openURL($url)"

	pack $f -side top -anchor nw

	if {$numhls_ > 6} {
		set h [expr 0.40 * $numhls_]
	} else {
		set h 2.5
	}

	$can conf -scrollregion "0 0 8.1i ${h}i"
	$can yview moveto 1
}

NewscastUI public is_interested { ck } {
	$self instvar pref_

	foreach p $pref_ {
		set cat [lindex $p 0]
		set lkw [lindex $p 1]
		foreach kw $lkw {
			if [$self intersect $ck [list $cat $kw]] {
				return 1
			}
		}
	}
	return 0
}

#
# Check whether the category in ck1 and ck2 is the same, and the keywords intersects.
#
NewscastUI private intersect { ck1 ck2 } {

	set c1 [lindex $ck1 0]
	set c2 [lindex $ck2 0]
	set k1 [lindex $ck1 1]
	set k2 [lindex $ck2 1]	
	
	if { "$c1" != "$c2" } {
		return 0
	} else {
		if { "$k1" == "*" || "$k2" == "*" || [llength [lintersect $k1 $k2]] > 0 } {
			return 1
		} else {
			return 0
		}
	}
}
	
