# 
#
#
proc havefont { f } { return 1 }

source tcl/common/application.tcl
source tcl/net/network.tcl
source tcl/common/log.tcl
source tcl/common/tkerror.tcl
source tcl/common/timer.tcl

source tcl/srmv2/source-srmv2.tcl
source tcl/srmv2/session-srmv2.tcl
source tcl/srmv2/manager-srmv2.tcl
source tcl/srmv2/text-srmv2.tcl
source tcl/srmv2/bt-srmv2.tcl

proc main args {
	set lst [lindex $args 0]
	if {[llength $lst] < 3} {
		puts ""
		puts -nonewline "Usage: bulk_transfer mcast_address/port/srmv2/ttl"
		puts " \[rate\] \[logfile\] \[src_dir\]" 
		puts ""
		puts "\t rate    = Maximum rate for token bucket. \n\t           Default = 128 Kb/s"  
		puts "\t logfile = Output file for traces. This is only a temporary"
                puts "\t           feature to allow emulation results to be logged."  
		puts "\t src_dir = Source of data. If unspecified, this is a receiver.\n"
		exit 1
	}
	set ab [lindex $lst 0]
	set peakrate [lindex $lst 1]

	set logfile  [lindex $lst 2]
	set filename [lindex $lst 3]
	puts "peakrate $peakrate filename $filename logfile $logfile"
	new BulkTransfer $ab $logfile $peakrate $filename 
}
main $argv


