#include <stdio.h>
#include <unistd.h>


void
Image2Tcl(const char *objectName)
{
  unsigned char buffer[1024], *ptr;
  int i, bytesRead, stdin_FD=0;
  printf("set %s [image create photo -data [new Image/GIF \"", objectName);
  while ((bytesRead=read(stdin_FD, buffer, sizeof(buffer))) > 0) {
    for (i=0, ptr=buffer; i<bytesRead; i++, ptr++) {
      switch (*ptr) {
      case '\0': 
	printf("\\%o\\%o", (unsigned short) '\\', (unsigned short) '#');
	break;
      case '\\': 
	printf("\\%o\\%o", (unsigned short) '\\', (unsigned short) '\\');
	break;
      default:   
	printf("\\%o", (unsigned short) *ptr); 
	break;
      }
    }
  }
  printf("\"]]\n");
}


int 
main(int argc, char *argv[])
{
  if (argc!=2) {
    fprintf(stderr, "Usage: image2tcl <object-name>\n");
    return -1;
  }
  Image2Tcl(argv[1]);
  return 0;
}

